CON _clkmode = xtal1 + pll16x
    _xinfreq = 5_000_000    

    SDPins  = 10
    audioR  = 9
    audioL  = 8
    playRate = 80_000_000/50
    
VAR
  byte  AYregs[16]
  byte  buffer[25]
  byte  filename[18]

  long  fileNumber

OBJ
  SID   : "AYcog_V0-22"
  SD    : "fsrw"

PUB Main | okay
 
  okay := SID.start( audioR, audioL, @AYregs )
  sd.mount( SDPins )

  fileNumber := 100
  openNextFile
   
  repeat
    waitcnt(cnt+playRate)
    if( sd.pread(@buffer, 16) ) => 0
      bytemove( @AYregs, @buffer, 13 )
      ifnot buffer[13] == 255
        byte[@AYregs + 13] := buffer[13]&15
    else
      fileNumber++
      openNextFile

PUB openNextFile | i, j
    sd.opendir
    repeat i from 0 to fileNumber
      sd.nextfile( @filename )
      repeat j from 0 to strsize(filename)
        if filename[j] == "."
          quit
      j++
      if filename[j] <> "Y" or filename[j+1] <> "M"
        i--
    if sd.popen( @filename, "r" ) == -1
    sd.pread(@buffer, 14)
    repeat i from 1 to 3
      sd.pread(@buffer, 16)
